summaryrefslogtreecommitdiffstats
path: root/package/base-files/brcm-2.6/sbin/mount_root
diff options
context:
space:
mode:
authornbd <nbd@3c298f89-4303-0410-b956-a3cf2f4a3e73>2006-06-15 17:21:17 +0000
committernbd <nbd@3c298f89-4303-0410-b956-a3cf2f4a3e73>2006-06-15 17:21:17 +0000
commit7885524586983ec44edf08324cfc7c63574b5388 (patch)
treeecb67bcf7ba9edd4ea60e1459a2085e07291d289 /package/base-files/brcm-2.6/sbin/mount_root
parent68f4a7a320968009c0c97ab7d685b09064af7e05 (diff)
clean up handling of the root filesystem mount - remove broadcom specific junk from the generic base-files part
git-svn-id: svn://svn.openwrt.org/openwrt/branches/buildroot-ng/openwrt@3951 3c298f89-4303-0410-b956-a3cf2f4a3e73
Diffstat (limited to 'package/base-files/brcm-2.6/sbin/mount_root')
-rwxr-xr-xpackage/base-files/brcm-2.6/sbin/mount_root38
1 files changed, 38 insertions, 0 deletions
diff --git a/package/base-files/brcm-2.6/sbin/mount_root b/package/base-files/brcm-2.6/sbin/mount_root
new file mode 100755
index 000000000..88a836c80
--- /dev/null
+++ b/package/base-files/brcm-2.6/sbin/mount_root
@@ -0,0 +1,38 @@
+#!/bin/sh
+is_dirty() {
+ grep Broadcom /proc/cpuinfo >&- || return 1
+ OFFSET="$(($(hexdump -v /dev/mtdblock/1 -s 20 -n 2 -e '"%d"')-1))"
+ return $(hexdump -v /dev/mtdblock/1 -s $OFFSET -n 1 -e '"%d"')
+}
+
+size=$(awk '/Mem:/ {l=5242880;print((s=$2/2)<l)?$2-l:s}' /proc/meminfo)
+mount none /tmp -t tmpfs -o size=$size
+
+if [ "$1" != "failsafe" ]; then
+ mtd unlock linux
+ mount | grep jffs2 >&-
+ if [ $? = 0 ] ; then
+ if [ $(cat /proc/mtd | wc -l) = 6 ]; then
+ mtd erase OpenWrt
+ jffs2root --move
+ else
+ mount -o remount,rw /dev/root /
+ fi
+ else
+ . /bin/firstboot
+ is_dirty
+ [ $? != 0 ] && {
+ echo "switching to jffs2"
+ mount /dev/mtdblock/4 /jffs -t jffs2
+ pivot /jffs /rom
+ } || {
+ echo "jffs2 unusable; using ramdisk"
+ ramoverlay
+ }
+ fi
+fi
+
+mount none /tmp -t tmpfs -o remount,nosuid,nodev,mode=1777
+mkdir -p /dev/pts
+mount none /dev/pts -t devpts
+mount -t sysfs none /sys 2>&-